public class Liste{
    
    private int val;
    private Liste suiv;
    
    public Liste(){ // liste vide avec sentinelle
	val = 0; 
	suiv = null;	
    }
    
    public Liste(int a){
	Liste x = new Liste(a, null);
        val = 0;
        suiv = x;
    }

    private Liste (int a, Liste x){
        val = a; 
	suiv = x;
    }
    
    public boolean estVide(){
	return suiv == null;
    }
    
    public int valeur() {
        if (estVide()) 
	    throw new RuntimeException("Valeur pour une  liste vide");
	return suiv.val;
    }
    
    public Liste reste(){
        if (estVide()) 
	    throw new RuntimeException("Reste pour une  liste vide");
        return suiv;
    }
    
    public void ajoutDebut(int a){
        Liste x = new Liste(a, suiv);
        this.suiv = x;
    }
    
    public void ajoutFin (int a){
	if (estVide()) 
	    ajoutDebut(a);
	else 
	    reste().ajoutFin(a);
    }
 
    public void supprimer (int a){
        Liste x = this;
        boolean trouve = false;
        while (!trouve && x.suiv != null ){
	    if (x.suiv.val == a) {
		trouve = true;
		x.suiv = x.suiv.suiv;
            }
            x = x.suiv;
	}
    }

    public int longueur(){
        return estVide() ? 0: 1 + reste().longueur();
    }
    
    public boolean appartient (int a){
        if (estVide()) 
	    return false;
        else if (valeur() == a) 
	    return true;
        else 
	    return reste().appartient(a);
    }

    public String toString(){
        if (estVide()) 
	    return "-> ";
        else
	    return "-> " + valeur() + reste().toString();
    }

    public Liste(int[] tab){
	this();
	for(int i = tab.length - 1; i >= 0; i--)
	    ajoutDebut(tab[i]);
    }

    public int nbOccurences(int a){
	int nb = 0;	
	for(Liste l = this; !l.estVide(); l = l.reste()) 
	    if  (l.valeur() == a) 
		nb++;
	return nb;
    }


    public int premiereOccurence(int a){
	Liste l;
	int i = 0;
        for(l=this; !l.estVide() && l.valeur()!=a; l=l.reste())
	    i++;
	if (l.estVide())
	    return -1;
	return i;
    }

    public int derniereOccurence(int a){
	int i = 0;
	int iDerniereOccurence = -1;
        for(Liste l=this; !l.estVide(); l=l.reste()){
	    if(l.valeur() == a)
		iDerniereOccurence = i;
	    i++;
	}
	return iDerniereOccurence;
    }

    public boolean equals(Object o){
	if(!(o instanceof Liste))
	    return false;
	
	Liste l = (Liste) o;
	Liste l1 = this;

	while (!l.estVide() && !l1.estVide() && l.valeur() == l1.valeur()){
	    l = l.reste();
	    l1 = l1.reste();
	}
	return l.estVide()&& l1.estVide();
    }
    
    public int valeur(int i){
	Liste l = this;
	while (!l.estVide() && i > 0){
	    l = l.reste();
	    i--;
	}
	if (i<0 || (l.estVide() && i>0))
	    throw new RuntimeException("Erreur d'indice");
	else
	    return valeur();
    }

    public void suppressionDebut(){
	if (estVide()) 
	    throw new RuntimeException("Suppression du 1er elt d'une  liste vide");
	suiv = suiv.suiv;
    }

    public void suppressionIeme(int i){
	Liste l = this;
	while (!l.estVide() && i > 0){
	    l = l.reste();
	    i--;
	}
	if (i<0 || (l.estVide() && i>0))
	    throw new RuntimeException("Erreur d'indice");
	l.suppressionDebut();
    }


    public void ajoutIeme(int a, int i){ // i est l'indice de l'élément ajouté
	Liste l = this;
	while (!l.estVide() && i > 0){
	    l = l.reste();
	    i--;
	}
	if (i <0 || (estVide() && i > 0 ))
	    throw new RuntimeException("Erreur d'indice");
	l.ajoutDebut(a);
    }

    public Liste sousListe(int ideb, int ifin){
	if (ideb <0 ||  ifin <0 )
	    throw new RuntimeException("Erreur d'indice");
	
	int i;
	Liste l = this;
	
	for(i = 0; i < ideb && !l.estVide(); i++)
	    l = l.reste();
	
	if (ideb < 0 || l.estVide() ) // ideb <0 || ideb >= longueur()
	    throw new RuntimeException("Erreur d'indice");
	
	Liste sl = new Liste();
	Liste slFin = sl;
	
	for( ; i <= ifin && !l.estVide(); i++){
	    slFin.ajoutDebut(l.valeur());
	    slFin = slFin.reste();
	    l = l.reste();
	}
	if (i==0 || ifin > i ) // ifin <0 || ifin >= longueur()
	    throw new RuntimeException("Erreur d'indice");
	
	return sl;
    }

   
    public static  Liste 
	concatenation(Liste l1, Liste l2){
	Liste ll = new Liste();
	Liste llfin = ll;
	
	Liste l;
        for(l=l1; !l.estVide(); l=l.reste()){
	    llfin.ajoutDebut(l.valeur());
	    llfin = llfin.reste();
	}
        for(l=l2; !l.estVide(); l=l.reste()){
	    llfin.ajoutDebut(l.valeur());
	    llfin = llfin.reste();
	}
	return ll;
    }
    
    public void 
	concatenation(Liste l){
	Liste fin = this;
	while (!fin.estVide())
	    fin = fin.reste();
	for(; !l.estVide(); l=l.reste(),fin=fin.reste())
	    fin.ajoutDebut(l.valeur());
    }    
}
